Summary: A Kanji code conversion filter.
Name: nkf
Version: 1.92
Release: 11a
License: BSD-like
Group: Applications/Text
# # Source: ftp://ftp.ie.u-ryukyu.ac.jp/pub/software/kono/nkf192.shar
Source0: nkf.c
Source1: nkf.1
Source2: nkf.1jeuc
Source3: nkf.doc
Source3: nkf.copyright
Patch: nkf-1.92-glibc2290.diff
Buildroot: %{_tmppath}/%{name}-%{version}-buildroot

%description
Nkf is a Kanji code converter for terminals, hosts, and networks. Nkf
converts input Kanji code to 7-bit JIS, MS-kanji (shifted-JIS) or
EUC.

%prep
%{__rm} -rf	$RPM_BUILD_ROOT
%{__mkdir_p}	$RPM_BUILD_ROOT/%{_bindir}
%{__mkdir_p}	$RPM_BUILD_ROOT%{_mandir}/{man1,ja/man1}

%setup -T -c 
%{__cp} $RPM_SOURCE_DIR/nkf.* .
%patch -p1 -b .glibc2290

%build
gcc $RPM_OPT_FLAGS -o nkf nkf.c

%install
install -m 755 nkf $RPM_BUILD_ROOT%{_bindir}
install -m 644 nkf.1 $RPM_BUILD_ROOT%{_mandir}/man1
install -m 644 nkf.1jeuc $RPM_BUILD_ROOT%{_mandir}/ja/man1/nkf.1

%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT

%files
%ifnos darwin
%defattr(-,root,root)
%else
%defattr(-,root,wheel)
%endif
%doc nkf.doc nkf.copyright
%{_bindir}/nkf
%{_mandir}/man1/nkf.1*
%{_mandir}/ja/man1/nkf.1*

%changelog
* Wed Oct 9 2002 Keisuke Fujii <fujiik@jlcuxf.kek.jp>
- 1st release on MacOS X 10.2.

* Fri Jun 21 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Wed Jun 19 2002 Akira TAGOH <tagoh@redhat.com> 1.92-10
- fix the stripped binary.
- s/Copyright/License/

* Mon Jun 03 2002 Yukihiro Nakai <ynakai@redhat.com>
- Add output bug patch for glibc-2.2.90 (#65864)

* Thu May 23 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Wed Jan 09 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Tue Sep  4 2001 SATO Satoru <ssato@redhat.com> - 1.92-6
- attached nkf.1jeuc(euc-jp) instead of nkf.1j(iso-2022-jp) (#53127)

* Sun Jun 24 2001 Elliot Lee <sopwith@redhat.com>
- Bump release + rebuild.

* Wed Feb 28 2001 SATO Satoru <ssato@redhat.com>
- nkf.copyright attached
- use system-defined macros (%%*dir)

* Tue Aug 29 2000 ISHIKAWA Mutsumi <ishikawa@redhat.com>
- adopt FHS

* Mon Aug  7 2000 ISHIKAWA Mutsumi <ishikawa@redhat.com>
- japanese manpages moved ja_JP.eucJP -> ja
- modified to be able to build by normal user.

* Tue Aug 01 2000 Yukihiro Nakai <ynakai@redhat.com>
- Update to 1.92
- rebuild for 7.0J

* Sat Mar 25 2000 Matt Wilson <msw@redhat.com>
- rebuilt for 6.2j
- support compressed man pages

* Wed Mar 22 2000 Chris Ding <cding@redhat.com>
- ja_JP.ujis -> ja_JP.eucJP

* Thu Oct  7 1999 Matt Wilson <msw@redhat.com>
- rebuilt against 6.1

* Sun May 30 1999 FURUSAWA,Kazuhisa <kazu@linux.or.jp>
- 1st Release for i386 (glibc2.1).
- Original Packager: Kazuhiko Mori(COW) <cow@he.mirai.ne.jp>

* Sun Jan 10 1999 Kazuhiko Mori(COW) <cow@he.mirai.ne.jp>
- just rebuilt for glibc TL. (release not changed.)

